* ApplySVD.F
* transform the n-by-n matrix A by the left and right transformation
* matrices V and W, i.e. form V^* A W^+ (or V^+ A W^* if UCOLS=1).
* The original matrix A is overwritten with the result.
* this file is part of the Diag library
* last modified 21 Aug 15 th

#include "diag-f.h"


	subroutine ApplySVD(m, n, A,ldA, V,ldV, W,ldW)
	implicit none
	integer m, n, ldA, ldV, ldW
	ComplexType A(ldA,*), V(ldV,*), W(ldW,*)

	integer nm, i, j, k
	ComplexType T(MAXDIM,MAXDIM), s

	nm = min(m, n)

	do j = 1, n
	  do i = 1, nm
	    s = 0
	    do k = 1, m
	      s = s + Conjugate(VL(i,k))*A(k,j)
	    enddo
	    T(i,j) = s
	  enddo
	enddo

	do j = 1, nm
	  do i = 1, nm
	    s = 0
	    do k = 1, n
	      s = s + T(i,k)*Conjugate(WL(j,k))
	    enddo
	    A(i,j) = s
	  enddo
	enddo
	end

