* ApplyTakagi.F
* transform the n-by-n matrix A by a unitary transformation U,
* i.e. form U^* A U^+ (or U^+ A U^* if UCOLS=1).
* The original matrix A is overwritten with the result.
* this file is part of the Diag library
* last modified 21 Aug 15 th

#include "diag-f.h"


	subroutine ApplyTakagi(n, A,ldA, U,ldU)
	implicit none
	integer n, ldA, ldU
	ComplexType A(ldA,*), U(ldU,*)

	integer i, j, k
	ComplexType T(MAXDIM,MAXDIM), s

	do j = 1, n
	  do i = 1, n
	    s = 0
	    do k = 1, n
	      s = s + A(i,k)*Conjugate(UL(j,k))
	    enddo
	    T(i,j) = s
	  enddo
	enddo

	do j = 1, n
	  do i = 1, n
	    s = 0
	    do k = 1, n
	      s = s + Conjugate(UL(i,k))*T(k,j)
	    enddo
	    A(i,j) = s
	  enddo
	enddo
	end

