* ReverseHEigen.F
* recover the original matrix A from the eigenvalues and
* the transformation matrix U by forming A = U^+ diag(d) U
* (or U diag(d) U^+ if UCOLS=1).
* this file is part of the Diag library
* last modified 21 Aug 15 th

#include "diag-f.h"


	subroutine ReverseHEigen(n, A,ldA, d, U,ldU)
	implicit none
	integer n, ldA, ldU
	ComplexType A(ldA,*), U(ldU,*)
	RealType d(*)

	integer i, j, k
	ComplexType s

	do j = 1, n
	  do i = 1, n
	    s = 0
	    do k = 1, n
#if UCOLS
	      s = s + d(k)*U(i,k)*Conjugate(U(j,k))
#else
	      s = s + d(k)*Conjugate(U(k,i))*U(k,j)
#endif
	    enddo
	    A(i,j) = s
	  enddo
	enddo
	end

