* ReverseSVD.F
* recover the original matrix A from the singular values and
* the left and right transformation matrices V and W by
* forming A = V^T diag(d) W (or A = V d W^T if UCOLS=1).
* this file is part of the Diag library
* last modified 21 Aug 15 th

#include "diag-f.h"


	subroutine ReverseSVD(m, n, A,ldA, d, V,ldV, W,ldW)
	implicit none
	integer m, n, ldA, ldV, ldW
	ComplexType A(ldA,*), V(ldV,*), W(ldW,*)
	RealType d(*)

	integer nm, i, j, k
	ComplexType s

	nm = min(m, n)

	do j = 1, n
	  do i = 1, m
	    s = 0
	    do k = 1, nm
	      s = s + d(k)*VL(k,i)*WL(k,j)
	    enddo
	    A(i,j) = s
	  enddo
	enddo
	end

