Install["build/Diag-quad"]

ran := Random[Integer, {1, 100}]

Aherm[i_, j_] := A[i, j] /; i < j;
Aherm[i_, i_] := Re[A[i, i]];
Aherm[i_, j_] := Conjugate[A[j, i]];

Asym[i_, j_] := A[i, j] /; i <= j;
Asym[i_, j_] := A[j, i];

norm[mat_] := Apply[Plus, Abs[mat], {0, 1}]

(* this is for UCOLS=0 *)
test0[n_] :=
Block[ {A, d, U, V, W},
  Ac = Array[(A[##] = ran + I ran)&, {n, n}];
  As = Array[Asym, {n, n}];
  Ah = Array[Aherm, {n, n}];
  zero = {
    {d, U} = HEigensystem[Ah];  U.Ah - DiagonalMatrix[d].U,
    {d, U} = SEigensystem[As];  U.As - DiagonalMatrix[d].U,
    {d, U} = CEigensystem[Ac];  U.Ac - DiagonalMatrix[d].U,
    {d, U} = TakagiFactor[As];  Conjugate[U].As - DiagonalMatrix[d].U,
    {V, d, W} = SVD[Ac];        Conjugate[V].Ac - DiagonalMatrix[d].W };
  norm/@ zero
]

(* this is for UCOLS=1 *)
test1[n_] :=
Block[ {A, d, U, V, W},
  Ac = Array[(A[##] = ran + I ran)&, {n, n}];
  As = Array[Asym, {n, n}];
  Ah = Array[Aherm, {n, n}];
  zero = {
    {d, U} = HEigensystem[Ah];  Ah.U - U.DiagonalMatrix[d],
    {d, U} = SEigensystem[As];  As.U - U.DiagonalMatrix[d],
    {d, U} = CEigensystem[Ac];  Ac.U - U.DiagonalMatrix[d],
    {d, U} = TakagiFactor[As];  As.Conjugate[U] - U.DiagonalMatrix[d],
    {V, d, W} = SVD[Ac];        Ac.Conjugate[W] - V.DiagonalMatrix[d] };
  norm/@ zero
]

